from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String

Dcmodify_V0_1_0 = CommandToolBuilder(tool="dcmodify", base_command=["dcmodify"], inputs=[ToolInput(tag="in_arguments", input_type=Boolean(optional=True), prefix="--arguments", doc=InputDocumentation(doc="print expanded command line arguments")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="quiet mode, print no warnings and errors")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="verbose mode, print processing details")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="debug mode, print debug information")), ToolInput(tag="in_log_level", input_type=Boolean(optional=True), prefix="--log-level", doc=InputDocumentation(doc="[l]evel: string constant\n(fatal, error, warn, info, debug, trace)\nuse level l for the logger")), ToolInput(tag="in_log_config", input_type=Boolean(optional=True), prefix="--log-config", doc=InputDocumentation(doc="[f]ilename: string\nuse config file f for the logger")), ToolInput(tag="in_read_dataset", input_type=Boolean(optional=True), prefix="--read-dataset", doc=InputDocumentation(doc="read data set without file meta information")), ToolInput(tag="in__readxferauto_use", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="=   --read-xfer-auto       use TS recognition (default)")), ToolInput(tag="in_read_xfer_detect", input_type=Boolean(optional=True), prefix="--read-xfer-detect", doc=InputDocumentation(doc="ignore TS specified in the file meta header")), ToolInput(tag="in_read_xfer_little", input_type=Boolean(optional=True), prefix="--read-xfer-little", doc=InputDocumentation(doc="read with explicit VR little endian TS")), ToolInput(tag="in_read_xfer_big", input_type=Boolean(optional=True), prefix="--read-xfer-big", doc=InputDocumentation(doc="read with explicit VR big endian TS")), ToolInput(tag="in_read_xfer_implicit", input_type=Boolean(optional=True), prefix="--read-xfer-implicit", doc=InputDocumentation(doc="read with implicit VR little endian TS")), ToolInput(tag="in_disable_correction", input_type=Boolean(optional=True), prefix="--disable-correction", doc=InputDocumentation(doc="disable automatic data correction")), ToolInput(tag="in_backup", input_type=Boolean(optional=True), prefix="--backup", doc=InputDocumentation(doc="backup files before modifying (default)")), ToolInput(tag="in_no_backup", input_type=Boolean(optional=True), prefix="--no-backup", doc=InputDocumentation(doc="don't backup files (DANGEROUS)")), ToolInput(tag="in_insert", input_type=Boolean(optional=True), prefix="--insert", doc=InputDocumentation(doc="'[t]ag-path=[v]alue'\ninsert (or overwrite) path at position t\nwith value v")), ToolInput(tag="in_insert_from_file", input_type=Boolean(optional=True), prefix="--insert-from-file", doc=InputDocumentation(doc="'[t]ag-path=[f]ilename'\ninsert (or overwrite) path at position t\nwith value from file f")), ToolInput(tag="in_no_reserv_check", input_type=Boolean(optional=True), prefix="--no-reserv-check", doc=InputDocumentation(doc="do not check private reservations\nwhen inserting private tags")), ToolInput(tag="in_modify", input_type=Boolean(optional=True), prefix="--modify", doc=InputDocumentation(doc="'[t]ag-path=[v]alue'\nmodify tag at position t to value v")), ToolInput(tag="in_modify_from_file", input_type=Boolean(optional=True), prefix="--modify-from-file", doc=InputDocumentation(doc="'[t]ag-path=[f]ilename'\nmodify tag at position t to value from file f")), ToolInput(tag="in_modify_all", input_type=Boolean(optional=True), prefix="--modify-all", doc=InputDocumentation(doc="'[t]ag=[v]alue'\nmodify ALL matching tags t in file to value v")), ToolInput(tag="in_erase", input_type=Boolean(optional=True), prefix="--erase", doc=InputDocumentation(doc="'[t]ag-path'\nerase tag/item at position t")), ToolInput(tag="in_erase_all", input_type=Boolean(optional=True), prefix="--erase-all", doc=InputDocumentation(doc="'[t]ag'\nerase ALL matching tags t in file")), ToolInput(tag="in_erase_private", input_type=Boolean(optional=True), prefix="--erase-private", doc=InputDocumentation(doc="erase ALL private data from file")), ToolInput(tag="in_gen_stud_uid", input_type=Boolean(optional=True), prefix="--gen-stud-uid", doc=InputDocumentation(doc="generate new Study Instance UID")), ToolInput(tag="in_gen_ser_uid", input_type=Boolean(optional=True), prefix="--gen-ser-uid", doc=InputDocumentation(doc="generate new Series Instance UID")), ToolInput(tag="in_gen_inst_uid", input_type=Boolean(optional=True), prefix="--gen-inst-uid", doc=InputDocumentation(doc="generate new SOP Instance UID")), ToolInput(tag="in_no_meta_uid", input_type=Boolean(optional=True), prefix="--no-meta-uid", doc=InputDocumentation(doc="do not update metaheader UIDs if related\nUIDs in the dataset are modified")), ToolInput(tag="in_ignore_errors", input_type=Boolean(optional=True), prefix="--ignore-errors", doc=InputDocumentation(doc="continue with file, if modify error occurs")), ToolInput(tag="in_ignore_missing_tags", input_type=Boolean(optional=True), prefix="--ignore-missing-tags", doc=InputDocumentation(doc="treat 'tag not found' as success\nwhen modifying or erasing in datasets")), ToolInput(tag="in_ignore_un_values", input_type=Boolean(optional=True), prefix="--ignore-un-values", doc=InputDocumentation(doc="do not try writing any values to elements\nhaving a VR of UN")), ToolInput(tag="in_write_dataset", input_type=Boolean(optional=True), prefix="--write-dataset", doc=InputDocumentation(doc="write data set without file meta information")), ToolInput(tag="in_disable_new_vr", input_type=Boolean(optional=True), prefix="--disable-new-vr", doc=InputDocumentation(doc="disable support for new VRs, convert to OB")), ToolInput(tag="in_group_length_remove", input_type=Boolean(optional=True), prefix="--group-length-remove", doc=InputDocumentation(doc="always write without group length elements")), ToolInput(tag="in_length_undefined", input_type=Boolean(optional=True), prefix="--length-undefined", doc=InputDocumentation(doc="write with undefined lengths")), ToolInput(tag="in__paddingretain_change", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="=   --padding-retain       do not change padding\n(default if not --write-dataset)")), ToolInput(tag="in_padding_off", input_type=Boolean(optional=True), prefix="--padding-off", doc=InputDocumentation(doc="no padding (implicit if --write-dataset)")), ToolInput(tag="in_dcm_file_in", input_type=String(), position=0, doc=InputDocumentation(doc="DICOM input filename to be modified"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Dcmodify_V0_1_0().translate("wdl", allow_empty_container=True)

